import { RouterMapType } from '../types/TRouter';
import Controller from './Controller';
export default abstract class RouterBase<T, K> {
    protected map: RouterMapType<T, K>;
    use(path: string, controller: Controller<T>): void;
    delete(awsPath: string): void;
    expose(): T;
    static errorToHttpError(e: any): {
        statusCode: any;
        body: any;
    };
}
